//
//CC1100.h
//
// Copyright (c) NewMSG. All rights reserved. 2007
// purpose : Test CC1100
// http://www.newmsg.com	
// http://www.newmsg.com/bbs

// [public]

#include "CC1100.h"


/****************************************************************************************
//ȫֱ
****************************************************************************************/
 
// 250k E  Sensitivity 䳤ݰ ַ	crc
const RF_SETTINGS rfSettings = {
    0x00,
    0x0B,   // FSCTRL1   Frequency synthesizer control.
    0x00,   // FSCTRL0   Frequency synthesizer control.
    0x10,   // FREQ2     Frequency control word, high byte.
    0xA7,   // FREQ1     Frequency control word, middle byte.
    0x62,   // FREQ0     Frequency control word, low byte.
    0x2D,   // MDMCFG4   Modem configuration.
    0x3B,   // MDMCFG3   Modem configuration.
    0x73,   // MDMCFG2   Modem configuration.
    0x22,   // MDMCFG1   Modem configuration.
    0xF8,   // MDMCFG0   Modem configuration.

    0x00,   // CHANNR    Channel number.
    0x00,   // DEVIATN   Modem deviation setting (when FSK modulation is enabled).
    0xB6,   // FREND1    Front end RX configuration.
    0x10,   // FREND0    Front end RX configuration.
    0x18,   // MCSM0     Main Radio Control State Machine configuration.
    0x1D,   // FOCCFG    Frequency Offset Compensation Configuration.
    0x1C,   // BSCFG     Bit synchronization Configuration.
    0xC7,   // AGCCTRL2  AGC control.
    0x00,   // AGCCTRL1  AGC control.
    0xB2,   // AGCCTRL0  AGC control.

    0xEA,   // FSCAL3    Frequency synthesizer calibration.
    0x0A,   // FSCAL2    Frequency synthesizer calibration.
    0x00,   // FSCAL1    Frequency synthesizer calibration.
    0x11,   // FSCAL0    Frequency synthesizer calibration.
    0x59,   // FSTEST    Frequency synthesizer calibration.
    0x88,   // TEST2     Various test settings.
    0x31,   // TEST1     Various test settings.
    0x0B,   // TEST0     Various test settings.
    0x0B,   // IOCFG2    GDO2 output pin configuration.
    //0x06,
    0x06,   // IOCFG0D   GDO0 output pin configuration. 
    
    0x04,   // PKTCTRL1  Packet automation control.	 
    0x45,   // PKTCTRL0  Packet automation control.	 //ɱ䳤ݰ,ͨͬʻĵһλݰ
    0xAA,   // ADDR      Device address.
    0xFF    // PKTLEN    Packet length.	28bytes
};


// PATABLE (0 dBm output power)
//INT8U PaTabel[8] = {0x60 ,0x60 ,0x60 ,0x60 ,0x60 ,0x60 ,0x60 ,0x60};
INT8U PaTabel[8] = {0xC0 ,0xC0 ,0xC0 ,0xC0 ,0xC0 ,0xC0 ,0xC0 ,0xC0};


unsigned char SPI_write(unsigned char value)
{
  unsigned char i,spi_status;
  for(i=0; i<8; i++)
  {
    SCK = 0;
    if(value&0x80)
       MOSI = 1;
    else
       MOSI = 0;
    
    value <<=1;
    SCK = 1;
    spi_status<<=1;	
    if(MISO_PIN)
       spi_status |= 0x01;
    else
       spi_status &= ~0x01;
  }
  SCK = 0;
  return(spi_status);
}

unsigned char SPI_read()
{
  unsigned char i,value;
  for(i=0;i<8;i++)
  {
    value <<=1;
    SCK = 1;
    if(MISO_PIN) 
      value |= 0x01;
    else 
      value &= ~0x01;

    SCK = 0;
    _NOP_nop(2);
  }
  
  return value;
}

//*****************************************************************************************
//void RESET_CC1100(void)
//룺
//
//λCC1100
//*****************************************************************************************
void RESET_CC1100(void) 
{
  CSN = 0; 
  
  while (MISO_PIN);
  SPI_write(CCxxx0_SRES); 		//д븴λ
  while (MISO_PIN); 
  CSN = 1; 
}

//*****************************************************************************************
//void POWER_UP_RESET_CC1100(void) 
//룺
//
//ϵ縴λCC1100
//*****************************************************************************************
void POWER_UP_RESET_CC1100(void) 
{
    CSN = 1; 
    _NOP_nop(50); 
    CSN = 0; 
    _NOP_nop(50);  
    CSN = 1; 
    _NOP_nop(600); 
    RESET_CC1100();   		//λCC1100
}

//*****************************************************************************************
//void halSpiWriteReg(INT8U addr, INT8U value)
//룺ַ
//
//SPIдĴ
//*****************************************************************************************
void halSpiWriteReg(INT8U addr, INT8U value) 
{
    CSN = 0;
    while (MISO_PIN);
    SPI_write(addr);		//дַ
    SPI_write(value);		//д
    CSN = 1;
}

//*****************************************************************************************
//void halSpiWriteBurstReg(INT8U addr, INT8U *buffer, INT8U count)
//룺ַд뻺д
//
//SPIдüĴ
//*****************************************************************************************
void halSpiWriteBurstReg(INT8U addr, INT8U *buffer, INT8U count) 
{
    INT8U i, temp;
    temp = addr | WRITE_BURST;
    CSN = 0;
    while (MISO_PIN);
    SPI_write(temp);
    for (i = 0; i < count; i++)
    {
      SPI_write(buffer[i]);
    }
    CSN = 1;
}

//*****************************************************************************************
//void halSpiStrobe(INT8U strobe)
//룺
//
//SPIд
//*****************************************************************************************
void halSpiStrobe(INT8U strobe) 
{
    CSN = 0;
    while (MISO_PIN);
    SPI_write(strobe);		//д
    CSN = 1;
}





//*****************************************************************************************
//INT8U halSpiReadReg(INT8U addr)
//룺ַ
//üĴ
//SPIĴ
//*****************************************************************************************
INT8U halSpiReadReg(INT8U addr) 
{
    INT8U temp, value;
    temp = addr|READ_SINGLE;//Ĵ
    CSN = 0;
    while (MISO_PIN);
    SPI_write(temp);
    value = SPI_read();
    CSN = 1;
    return value;
}


//*****************************************************************************************
//void halSpiReadBurstReg(INT8U addr, INT8U *buffer, INT8U count)
//룺ַݺݴĻø
//
//SPIдüĴ
//*****************************************************************************************
void halSpiReadBurstReg(INT8U addr, INT8U *buffer, INT8U count) 
{
    INT8U i,temp;
    temp = addr | READ_BURST;		//дҪüĴַͶ
    CSN = 0;
    while (MISO_PIN);
    SPI_write(temp);   
    for (i = 0; i < count; i++) 
    {
    buffer[i] = SPI_read();
    }
    CSN = 1;
}


//*****************************************************************************************
//INT8U halSpiReadReg(INT8U addr)
//룺ַ
//״̬Ĵǰֵ
//SPI״̬Ĵ
//*****************************************************************************************
INT8U halSpiReadStatus(INT8U addr) 
{
    INT8U value,temp;
    temp = addr | READ_BURST;		//дҪ״̬Ĵĵַͬʱд
    CSN = 0;
    while (MISO_PIN);
    SPI_write(temp);
    value = SPI_read();
    CSN = 1;
    return value;
}


//*****************************************************************************************
//void halRfWriteRfSettings(RF_SETTINGS *pRfSettings)
//룺
//
//CC1100ļĴ
//*****************************************************************************************
void halRfWriteRfSettings(void) 
{
    halSpiWriteReg(CCxxx0_FSCTRL0,  rfSettings.FSCTRL2);//Ѽӵ
    // Write register settings
    halSpiWriteReg(CCxxx0_FSCTRL1,  rfSettings.FSCTRL1);
    halSpiWriteReg(CCxxx0_FSCTRL0,  rfSettings.FSCTRL0);
    halSpiWriteReg(CCxxx0_FREQ2,    rfSettings.FREQ2);
    halSpiWriteReg(CCxxx0_FREQ1,    rfSettings.FREQ1);
    halSpiWriteReg(CCxxx0_FREQ0,    rfSettings.FREQ0);
    halSpiWriteReg(CCxxx0_MDMCFG4,  rfSettings.MDMCFG4);
    halSpiWriteReg(CCxxx0_MDMCFG3,  rfSettings.MDMCFG3);
    halSpiWriteReg(CCxxx0_MDMCFG2,  rfSettings.MDMCFG2);
    halSpiWriteReg(CCxxx0_MDMCFG1,  rfSettings.MDMCFG1);
    halSpiWriteReg(CCxxx0_MDMCFG0,  rfSettings.MDMCFG0);
    halSpiWriteReg(CCxxx0_CHANNR,   rfSettings.CHANNR);
    halSpiWriteReg(CCxxx0_DEVIATN,  rfSettings.DEVIATN);
    halSpiWriteReg(CCxxx0_FREND1,   rfSettings.FREND1);
    halSpiWriteReg(CCxxx0_FREND0,   rfSettings.FREND0);
    halSpiWriteReg(CCxxx0_MCSM0 ,   rfSettings.MCSM0 );
    halSpiWriteReg(CCxxx0_FOCCFG,   rfSettings.FOCCFG);
    halSpiWriteReg(CCxxx0_BSCFG,    rfSettings.BSCFG);
    halSpiWriteReg(CCxxx0_AGCCTRL2, rfSettings.AGCCTRL2);
    halSpiWriteReg(CCxxx0_AGCCTRL1, rfSettings.AGCCTRL1);
    halSpiWriteReg(CCxxx0_AGCCTRL0, rfSettings.AGCCTRL0);
    halSpiWriteReg(CCxxx0_FSCAL3,   rfSettings.FSCAL3);
    halSpiWriteReg(CCxxx0_FSCAL2,   rfSettings.FSCAL2);
    halSpiWriteReg(CCxxx0_FSCAL1,   rfSettings.FSCAL1);
    halSpiWriteReg(CCxxx0_FSCAL0,   rfSettings.FSCAL0);
    halSpiWriteReg(CCxxx0_FSTEST,   rfSettings.FSTEST);
    halSpiWriteReg(CCxxx0_TEST2,    rfSettings.TEST2);
    halSpiWriteReg(CCxxx0_TEST1,    rfSettings.TEST1);
    halSpiWriteReg(CCxxx0_TEST0,    rfSettings.TEST0);
    halSpiWriteReg(CCxxx0_IOCFG2,   rfSettings.IOCFG2);
    halSpiWriteReg(CCxxx0_IOCFG0,   rfSettings.IOCFG0);    
    halSpiWriteReg(CCxxx0_PKTCTRL1, rfSettings.PKTCTRL1);
    halSpiWriteReg(CCxxx0_PKTCTRL0, rfSettings.PKTCTRL0);
    halSpiWriteReg(CCxxx0_ADDR,     rfSettings.ADDR);
    halSpiWriteReg(CCxxx0_PKTLEN,   rfSettings.PKTLEN);
    
   // halSpiWriteReg(CCxxx0_MCSM2,0x01);
    //halSpiWriteReg(CCxxx0_WORCTRL,0x78);
   halSpiWriteReg(CCxxx0_WOREVT1, 0x08);//λ
   halSpiWriteReg(CCxxx0_WOREVT0, 0xc5);//λ0X32C8
   halSpiWriteReg(CCxxx0_WORCTRL, 0x38);//WOR_RES=1,¼01ʱ  
   halSpiWriteReg(CCxxx0_MCSM2, 0x00);//ֻͬʻ㣬RXֹʱ0.75 

}






//*****************************************************************************************
//void halRfSendPacket(INT8U *txBuffer, INT8U size)
//룺͵Ļݸ
//
//CC1100һ
//*****************************************************************************************

void halRfSendPacket(INT8U *txBuffer, INT8U size) 
{
  halSpiWriteReg(CCxxx0_TXFIFO, size);
  halSpiWriteBurstReg(CCxxx0_TXFIFO, txBuffer, size);	//дҪ͵
  halSpiStrobe(CCxxx0_STX);		                //뷢ģʽ
  // Wait for GDO0 to be set -> sync transmitted
  while (!GDO0_PIN);
  // Wait for GDO0 to be cleared -> end of packet
  while (GDO0_PIN);
  //halSpiStrobe(CCxxx0_SFTX);
}



INT8U halRfReceivePacket(INT8U *rxBuffer, INT8U length) 
{
    INT8U status[2],tmp;
    INT8U packetLength;

    halSpiStrobe(CCxxx0_SRX);		//״̬
    _NOP_us(300);
   tmp=length;// Ҫӳȣ
    while (GDO0_PIN && tmp)
    {
      _NOP_ms(1);
      tmp--;
    }
    if(tmp<=0)
    {
      return 0;
    }
	
    if ((halSpiReadStatus(CCxxx0_RXBYTES) & BYTES_IN_RXFIFO)) //ӵֽΪ0
    {
        packetLength = halSpiReadReg(CCxxx0_RXFIFO);//һֽڣֽΪ֡ݳ
        if (packetLength <= length) 		   //ҪЧݳСڵڽյݰĳ
        {
            halSpiReadBurstReg(CCxxx0_RXFIFO, rxBuffer, packetLength); //нյ
            //*length = packetLength;				      //ѽݳȵ޸Ϊǰݵĳ
            
            // Read the 2 appended status bytes (status[0] = RSSI, status[1] = LQI)
            halSpiReadBurstReg(CCxxx0_RXFIFO, status, 2); 	     //CRCУλ
            
            //halSpiStrobe(CCxxx0_SFRX);		//ϴջ
            return (status[1] & CRC_OK);		//Уɹؽճɹ
        }
        else 
        {
            //*length = packetLength;
            halSpiStrobe(CCxxx0_SIDLE);
            halSpiStrobe(CCxxx0_SFRX);		//ϴջ
            return 0;
        }
    } 
    else
     return 0;
}

void initialcc1100()
{
    SCK_DDR=1;      
    GDO2_DDR=0;      
    CSN_DDR=1;      
    MOSI_DDR=1;    
    MISO_DDR=0;     
    GDO0_DDR=0; 
    
    GDO2=1;
    MISO=1;
    GDO0=1;
    MOSI=0;
    
    CSN=0;
    SCK=0;
    CSN=1;

    _NOP_ms(10);
    POWER_UP_RESET_CC1100();
    halRfWriteRfSettings();
    halSpiWriteBurstReg(CCxxx0_PATABLE, PaTabel, 8);
}
