#include "fly8000.h"
#include "CC1100.h"

pdata uint8 CC1100_TxRxBuf[1+CC1100_DATA_LEN ];
pdata uint8 CC1100_TxAddr = 0x01;
pdata uint8 CC1100_RxAddr = 0x01;
code  PaTabel[8] = {0x60, 0x60, 0x60, 0x60,  0x60,  0x60, 0x60, 0x60};

//--------------------------CC1100 Ĵ---------------------------------
code CC1100_RF_SETTINGS CC1100_Config = 
{
	0x07,   // IOCFG2    GDO2 output pin configuration.
	0x06,    //IOCFG1
	0x06,   // IOCFG0   GDO0 output pin configuration. 
	0x07,    //FIFOTHR
	0xD3,	//SYNC1 MSB
	0x91,      //SYNC0 LSB
	1+CC1100_DATA_LEN,    // PKTLEN    Packet length.
	0x0A,    // PKTCTRL1  Packet automation control.
	0x04,   // PKTCTRL0  Packet automation control.
	0x01,   // ADDR      Device address.
	
	0x00,   // CHANNR    Channel number.
	0x08,   // FSCTRL1   Frequency synthesizer control.
	0x00,   // FSCTRL0   Frequency synthesizer control.
	0x10,   // FREQ2     Frequency control word, high byte.
	0xA7,   // FREQ1     Frequency control word, middle byte.
	0x62,   // FREQ0     Frequency control word, low byte.
	0x5B,   // MDMCFG4   Modem configuration.
	0xF8,   // MDMCFG3   Modem configuration.
	0x03,   // MDMCFG2   Modem configuration.
	0x22,   // MDMCFG1   Modem configuration.

	0xF8,   // MDMCFG0   Modem configuration.
	0x47,   // DEVIATN   Modem deviation setting (when FSK modulation is enabled).
	0x00,    // MCSM2     Main Radio Control State Machine configuration.
	0x02,    // MCSM1     Main Radio Control State Machine configuration.
	0x18,    // MCSM0     Main Radio Control State Machine configuration.
	0x1D,   // FOCCFG    Frequency Offset Compensation Configuration.
	0x1C,   // BSCFG     Bit synchronization Configuration.
	0xC7,   // AGCCTRL2  AGC control.
	0x00,   // AGCCTRL1  AGC control.
	0xB2,   // AGCCTRL0  AGC control.

	0x00,   // WOREVT1
       0x00,   // WOREVT0
       0x00,   // WORCTRL
    	0xB6,   // FREND1    Front end RX configuration.
	0x10,   // FREND0    Front end RX configuration.
	0xEA,   // FSCAL3    Frequency synthesizer calibration.
	0x2A,   // FSCAL2    Frequency synthesizer calibration.
	0x00,   // FSCAL1    Frequency synthesizer calibration.
	0x11,   // FSCAL0    Frequency synthesizer calibration.
	0x00,    //RCCTRL1

	0x00,    //RCCTRL0
	0x59,   // FSTEST    Frequency synthesizer calibration.
	0x00,    //PTEST
	0x00,   //AGCTEST
	0x81,   // TEST2     Various test settings.
	0x35,   // TEST1     Various test settings.
	0x09,   // TEST0     Various test settings.
};

//---------------------------CC1100ƵоƬʼ-------------------------------------- 
void CC1100_Init(void) 
{
	CSN_ON(); 
	delay_ms(1);
	CSN_OFF(); 
	delay_ms(1);
	CSN_ON(); 
	delay_ms(1);

	CC1100_Command(CCxxx0_SRES); 		//д븴λ
	delay_ms(1);

	CC1100_WriteReg(CCxxx0_FSCTRL1,  CC1100_Config.FSCTRL1);
	CC1100_WriteReg(CCxxx0_FSCTRL0,  CC1100_Config.FSCTRL0);
	CC1100_WriteReg(CCxxx0_FREQ2,    CC1100_Config.FREQ2);
	CC1100_WriteReg(CCxxx0_FREQ1,    CC1100_Config.FREQ1);
	CC1100_WriteReg(CCxxx0_FREQ0,    CC1100_Config.FREQ0);
	CC1100_WriteReg(CCxxx0_MDMCFG4,  CC1100_Config.MDMCFG4);
	CC1100_WriteReg(CCxxx0_MDMCFG3,  CC1100_Config.MDMCFG3);
	CC1100_WriteReg(CCxxx0_MDMCFG2,  CC1100_Config.MDMCFG2);
	CC1100_WriteReg(CCxxx0_MDMCFG1,  CC1100_Config.MDMCFG1);
	CC1100_WriteReg(CCxxx0_MDMCFG0,  CC1100_Config.MDMCFG0);
	CC1100_WriteReg(CCxxx0_CHANNR,   CC1100_Config.CHANNR);
	CC1100_WriteReg(CCxxx0_DEVIATN,  CC1100_Config.DEVIATN);
	CC1100_WriteReg(CCxxx0_FREND1,   CC1100_Config.FREND1);
	CC1100_WriteReg(CCxxx0_FREND0,   CC1100_Config.FREND0);
	CC1100_WriteReg(CCxxx0_MCSM0 ,   CC1100_Config.MCSM0 );
	CC1100_WriteReg(CCxxx0_FOCCFG,   CC1100_Config.FOCCFG);
	CC1100_WriteReg(CCxxx0_BSCFG,    CC1100_Config.BSCFG);
	CC1100_WriteReg(CCxxx0_AGCCTRL2, CC1100_Config.AGCCTRL2);
	CC1100_WriteReg(CCxxx0_AGCCTRL1, CC1100_Config.AGCCTRL1);
	CC1100_WriteReg(CCxxx0_AGCCTRL0, CC1100_Config.AGCCTRL0);
	CC1100_WriteReg(CCxxx0_FSCAL3,   CC1100_Config.FSCAL3);
	CC1100_WriteReg(CCxxx0_FSCAL2,   CC1100_Config.FSCAL2);
	CC1100_WriteReg(CCxxx0_FSCAL1,   CC1100_Config.FSCAL1);
	CC1100_WriteReg(CCxxx0_FSCAL0,   CC1100_Config.FSCAL0);
	CC1100_WriteReg(CCxxx0_FSTEST,   CC1100_Config.FSTEST);
	CC1100_WriteReg(CCxxx0_TEST2,    CC1100_Config.TEST2);
	CC1100_WriteReg(CCxxx0_TEST1,    CC1100_Config.TEST1);
	CC1100_WriteReg(CCxxx0_TEST0,    CC1100_Config.TEST0);
	CC1100_WriteReg(CCxxx0_IOCFG2,   CC1100_Config.IOCFG2);
	CC1100_WriteReg(CCxxx0_IOCFG0,   CC1100_Config.IOCFG0);    
	CC1100_WriteReg(CCxxx0_PKTCTRL1, CC1100_Config.PKTCTRL1);
	CC1100_WriteReg(CCxxx0_PKTCTRL0, CC1100_Config.PKTCTRL0);
	CC1100_WriteReg(CCxxx0_ADDR,     CC1100_Config.ADDR);
	CC1100_WriteReg(CCxxx0_PKTLEN,   CC1100_Config.PKTLEN);

	//CC1100_WriteBurstReg(CCxxx0_PATABLE, PaTabel, 8);
	CC1100_Command(CCxxx0_SFRX);
	CC1100_Command(CCxxx0_SFTX);
	CC1100_Command(CCxxx0_SIDLE);
	delay_ms(1);
}

//---------------------------CC1100ýģʽ-------------------------------------- 
void CC1100_SetRxMode(void)
{
	CC1100_Command(CCxxx0_SRX);
}

//---------------------------CC1100ݰպ-------------------------------------- 
uint8 CC1100_RxPacket(void) 
{
	if(GDO2)
	{
		  if(CC1100_ReadReg(CCxxx0_PKTSTATUS|READ_BURST)&0x80)
		  {		
		  	if((1+CC1100_DATA_LEN) == CC1100_ReadReg(CCxxx0_RXBYTES|READ_BURST))
			{
				CC1100_ReadBurstReg(CCxxx0_RXFIFO, CC1100_TxRxBuf, 1+CC1100_DATA_LEN);    //нյ
				return  TRUE;
		 	  }
		 }
	}
	return  FALSE;
}

//---------------------------CC1100ݰͺ-------------------------------------- 
void CC1100_TxPacket(void) 
{
	CC1100_WriteBurstReg(CCxxx0_TXFIFO, CC1100_TxRxBuf,1+CC1100_DATA_LEN);	//дҪ͵
	CC1100_Command(CCxxx0_STX);		                                   //뷢ģʽ

	while (!GDO0);// Wait for GDO0 to be set -> sync transmitted
	while (GDO0);// Wait for GDO0 to be cleared -> end of packet
	
	CC1100_Command(CCxxx0_SFTX);          //ˢ·ͻ
	CC1100_Command(CCxxx0_SIDLE);
}

//---------------------------CC1100Ĵд뺯-------------------------------------- 
void CC1100_WriteReg(uint8 addr, uint8 value) 
{
	CSN_OFF();
	while (MISO);
	SPI_Write(addr|WRITE_SINGLE);		       //дַ
	SPI_Write(value);		                            //д
	CSN_ON();
}
//---------------------------CC1100Ĵȡ-------------------------------------- 
uint8 CC1100_ReadReg(uint8 addr) 
{
	uint8 value;
	CSN_OFF();
	while (MISO);
	SPI_Write(addr|READ_SINGLE);
	value = SPI_Read();
	CSN_ON();
	return value;
}
//---------------------------CC1100Ĵд뺯-------------------------------------- 
void CC1100_WriteBurstReg(uint8 addr, uint8 *buffer, uint8 count) 
{
	uint8 i;
	CSN_OFF();
	while (MISO);
	SPI_Write(addr | WRITE_BURST);
	for (i = 0; i < count; i++)
	{
		SPI_Write(buffer[i]);
	}
	CSN_ON();
}
//---------------------------CC1100Ĵȡ-------------------------------------- 
void CC1100_ReadBurstReg(uint8 addr, uint8 *buffer, uint8 count) 
{
	uint8 i;
	CSN_OFF();
	while (MISO);
	SPI_Write(addr | READ_BURST);   
	for (i = 0; i < count; i++) 
	{
		buffer[i] = SPI_Read();
	}
	CSN_ON();
}
//----------------------------CC1100------------------------------
void CC1100_Command(uint8 cmd) 
{
	CSN_OFF();
	while (MISO);
	SPI_Write(cmd);		//д
	CSN_ON();
}
//---------------------------CC1100յַú-------------------------------------- 
void CC1100_Write_RxADDR(void)
{
	CC1100_WriteReg(CCxxx0_ADDR,CC1100_RxAddr);
}
//---------------------------CC1100͵ַú-------------------------------------- 
void CC1100_Write_TxADDR(void)
{
	CC1100_TxRxBuf[0] = CC1100_TxAddr;       
}

//--------------------------SPIʼ---------------------------
void SPI_Init(void)
{
	CSN_ON();    
	SCK_OFF();
}

//--------------------------SPIֽڶȡ---------------------------
uint8 SPI_Read(void)
{
	uint8 i,rxdata;
	rxdata = 0x00;
	for (i = 0;i < 8;i++)
	{
		rxdata = rxdata<<1;
		SCK_ON();
		if (MISO)	//ȡλĩβͨλֽ
		{
			rxdata |= 0x01;
		}
		else
		{
			rxdata &= ~0x01;
		}
		SCK_OFF();
	 }
	 return rxdata;
}

//----------------------------SPIֽд뺯---------------------------
void SPI_Write(uint8 txdata)
{
	uint8 i;
	for (i = 0;i < 8;i++)
	{
		if (txdata&0x80)	//Ƿλ
		{
			MOSI_ON();
		}
		else
		{
			MOSI_OFF();
		}
		SCK_ON();
		txdata = txdata<<1;
		SCK_OFF();
	}
}

