#include "CC1100.h"
#include "fly8000.h"

extern pdata uint8 CC1100_TxRxBuf[1+CC1100_DATA_LEN ];
extern pdata uint8 CC1100_TxAddr ;
extern pdata uint8 CC1100_RxAddr;

pdata uint8 UART_Receive_Count = 0;
pdata uint8 UART_Receive_Flag = FALSE;
pdata uint8 UART_TxRxBuf[UART_TxRxBuf_Len];
//just for test using only
pdata uint8 test_i = 0; 

//-------------------IOڳʼ-------------------------------
void IO_Init(void)
{
	GDO2 = 1 ;       
	GDO0 = 1 ; 
	MISO = 1 ; 
	
	S2_IN  = 1; 
}

//-----------------------1 ʱ---------------------------------
//STC10F8XE   11.0592 ʵֵ
void delay_ms(uint8 n)
{
	uint8 i;
       while(n--)
	{
		for(i=0;i<255;i++);
		for(i=0;i<255;i++);
		for(i=0;i<255;i++);
		for(i=0;i<255;i++);
		for(i=0;i<255;i++);
		for(i=0;i<160;i++);
	}
}

//------------------------10 ΢ʱ---------------------------------
//STC10F8XE  11.0592 ʵֵn=1    ʵ13us;    n=100    ʵ1ms
void delay_10us(uint8 n)
{
	uint8 i;
       while(n--)
	{
		for(i=0;i<7;i++);
	}
}

//-----------------------ڳʼ------------------------
void UART_Init(void)
{
	TMOD = 0x20;				//timer1 working mode 1
	TL1  = 0xfd;					
	TH1  = 0xfd;					//19200 ( 11.0592)
	ET1=0;
	SCON = 0x50;				//uart mode 1,ren==1,
	PCON = 0x80;				      //smod=1
	TR1  = 1;					      //start timer1
       ES = 1;
}
//-------------------------ڵֽڷͺ------------------------------
void UART_SendByte(uint8 send)
{	
	 SBUF = send;  
        while( TI == 0 );				
  	 TI = 0;    
}
//-------------------------ַͺ------------------------------
void UART_SendString(uint8*  Str)
{
        while(*Str != NULL)
	{
		UART_SendByte(Str[0]);
		++Str;
	}
	   
} 
//-------------------------ж------------------------------
void UART_INT() interrupt 4 
{
	if(RI)
	{
		uint16 count = 0xFFFF;
		while(1)
		{
			
			while(!RI)
			{
				if(count == 0)
				{
					UART_Receive_Flag = TRUE;
					return ;
				}
				count--;
			}
			UART_TxRxBuf [UART_Receive_Count++] = SBUF;
			RI = 0;
		}

		
	}	
	else
	{
	//	TI = 0;
	}
	
} 
//---------------ͨѶ--------------------
//һʽ(1)+ݳ(1)+
void UART_Parse(void)
{ 
	uint8 i;
	switch(UART_TxRxBuf[0])
	{
		case UART_READ_BACK:
			for (i = 0 ;i < UART_Receive_Count;i++)
			{ 
		                UART_SendByte(UART_TxRxBuf[i]);
			}
			break;
			
		case  CC1100_READ_RXADDR:
			UART_SendByte( CC1100_RxAddr);
		   	break;
		case  CC1100_READ_TXADDR:
			UART_SendByte( CC1100_TxAddr);
		   	break;
		case  CC1100_WRITE_RXADDR:
			CC1100_RxAddr = UART_TxRxBuf[2];
			break;	
		case  CC1100_WRITE_TXADDR:
			CC1100_TxAddr = UART_TxRxBuf[2];
			break;			
		case  CC1100_READ_BUF32:
			for (i=0;i<CC1100_DATA_LEN;i++)	       
			{
				UART_SendByte(CC1100_TxRxBuf[1+i]);
			}				        
			break;
		case CC1100_READ_REG:
			UART_SendByte(CC1100_ReadReg(UART_TxRxBuf[2]));
			break;		
		case CC1100_WRITE_BUF32:
			for (i=0;i<CC1100_DATA_LEN;i++)	       
			{
				CC1100_TxRxBuf[1+i] = UART_TxRxBuf[i+2];
			}
			break;
		case CC1100_WRITE_REG:
			CC1100_WriteReg(UART_TxRxBuf[2], UART_TxRxBuf[3]);
			break;
		case CC1100_SET_RXMODE:
			CC1100_SetRxMode();
			break;
		case CC1100_RX:
			if(CC1100_RxPacket())
			{
				for (i=0; i<CC1100_DATA_LEN; i++)
				{
					UART_SendByte(CC1100_TxRxBuf[1+i] );
				}
			}
			break;
		case CC1100_CMD:
			CC1100_Command(UART_TxRxBuf[2]);
			break;
		case CC1100_TX:
			CC1100_TxPacket();
			break;
		case CC1100_INIT:
			CC1100_Init();
			break;

		default:
		       break;
	}   
	UART_Receive_Flag = FALSE;
	UART_Receive_Count = 0 ;
}

 void main(void)
{
	uint8 i,keycount;;
	
	IO_Init();
       UART_Init(); 
	SPI_Init();
	EA = 1;

       CC1100_Init();
	CC1100_Write_RxADDR();
	CC1100_SetRxMode();
	
	while(1)
	{		
		if (UART_Receive_Flag)
		{	
			delay_ms(100);
			UART_Parse();
		}
		else
		{
			if(!S2_IN)
			{
				keycount = 0;
				for(i=0;i<100;i++)
				{
					if(!S2_IN)
					{
						keycount ++;
					}
					else
					{
						break;
					}  
					delay_ms(1);
				}

				if(keycount>=100)
				{
					for(i=0;i<CC1100_DATA_LEN;i++)
					{
						CC1100_TxRxBuf[1+i] = test_i;
						test_i++;
					}
					CC1100_Write_TxADDR();
					CC1100_TxPacket();
					CC1100_SetRxMode();
					
					for(i=0;i<4;i++)
					{
						LED2_ON();
						delay_ms(100);
						LED2_OFF();
						delay_ms(100);
					}
					
				}
				
			}
			else
			{
				if(CC1100_RxPacket())
				{
					for(i=0;i<CC1100_DATA_LEN;i++)
					{
						UART_SendByte(CC1100_TxRxBuf[1+i]);
					}
					CC1100_SetRxMode();
					
					for(i=0;i<4;i++)
					{
						LED2_ON();
						LED1_ON();
						delay_ms(100);
						LED2_OFF();
						LED1_OFF();
						delay_ms(100);
					}
				}
			 }
		}	
	}  
}
