#include <msp430x14x.h>
//==============================================================================
#define  INT8U    unsigned char
#define  INT16U   unsigned int
#define  uclong   unsigned long
//===================================ӳ===================================
#define  MISO_0     P3OUT &=~BIT2      
#define  MISO_1     P3OUT |= BIT2         
//======================================================================
#define  MOSI_0     P3OUT &=~BIT1         
#define  MOSI_1     P3OUT |= BIT1        
//===================================SPIʱӶ˿================================
#define  SCK_0      P3OUT &=~BIT3         
#define  SCK_1      P3OUT |= BIT3         
//==================================SPIʹܶ˿=================================
#define  CSN_0      P3OUT &=~BIT0
#define  CSN_1      P3OUT |= BIT0
//==========================GDO0״̬============================================
#define  GDO0_0       P2OUT &=~BIT7       
#define  GDO0_1       P2OUT |= BIT7
//=========================GDO2״̬=============================================
#define  GDO2_0       P2OUT &=~BIT6
#define  GDO2_1       P2OUT |= BIT6
//==============================================================================
#define  LED1_0     P6OUT &=~BIT1          //0
#define  LED1_1     P6OUT |= BIT1          //1
#define  LED2_0     P6OUT &=~BIT2          //0
#define  LED2_1     P6OUT |= BIT2          //1
//==============================================================================
#define  WRITE_BURST         0x40	//д
#define  READ_SINGLE         0x80	//
#define  READ_BURST          0xC0	//
#define  BYTES_IN_RXFIFO     0x7F  	//ջЧֽ
#define  CRC_OK              0x80 	//CRCУͨλ־
//*****************************************************************************************
// CC1100-CC1101  ؼĴӳ 
#define CCxxx0_IOCFG2       0x00        // GDO2 output pin configuration
#define CCxxx0_IOCFG1       0x01        // GDO1 output pin configuration
#define CCxxx0_IOCFG0       0x02        // GDO0 output pin configuration
#define CCxxx0_FIFOTHR      0x03        // RX FIFO and TX FIFO thresholds
#define CCxxx0_SYNC1        0x04        // Sync word, high INT8U
#define CCxxx0_SYNC0        0x05        // Sync word, low INT8U
#define CCxxx0_PKTLEN       0x06        // Packet length
#define CCxxx0_PKTCTRL1     0x07        // Packet automation control
#define CCxxx0_PKTCTRL0     0x08        // Packet automation control
#define CCxxx0_ADDR         0x09        // Device address
#define CCxxx0_CHANNR       0x0A        // Channel number
#define CCxxx0_FSCTRL1      0x0B        // Frequency synthesizer control
#define CCxxx0_FSCTRL0      0x0C        // Frequency synthesizer control
#define CCxxx0_FREQ2        0x0D        // Frequency control word, high INT8U
#define CCxxx0_FREQ1        0x0E        // Frequency control word, middle INT8U
#define CCxxx0_FREQ0        0x0F        // Frequency control word, low INT8U
#define CCxxx0_MDMCFG4      0x10        // Modem configuration
#define CCxxx0_MDMCFG3      0x11        // Modem configuration
#define CCxxx0_MDMCFG2      0x12        // Modem configuration
#define CCxxx0_MDMCFG1      0x13        // Modem configuration
#define CCxxx0_MDMCFG0      0x14        // Modem configuration
#define CCxxx0_DEVIATN      0x15        // Modem deviation setting
#define CCxxx0_MCSM2        0x16        // Main Radio Control State Machine configuration
#define CCxxx0_MCSM1        0x17        // Main Radio Control State Machine configuration
#define CCxxx0_MCSM0        0x18        // Main Radio Control State Machine configuration
#define CCxxx0_FOCCFG       0x19        // Frequency Offset Compensation configuration
#define CCxxx0_BSCFG        0x1A        // Bit Synchronization configuration
#define CCxxx0_AGCCTRL2     0x1B        // AGC control
#define CCxxx0_AGCCTRL1     0x1C        // AGC control
#define CCxxx0_AGCCTRL0     0x1D        // AGC control
#define CCxxx0_WOREVT1      0x1E        // High INT8U Event 0 timeout
#define CCxxx0_WOREVT0      0x1F        // Low INT8U Event 0 timeout
#define CCxxx0_WORCTRL      0x20        // Wake On Radio control
#define CCxxx0_FREND1       0x21        // Front end RX configuration
#define CCxxx0_FREND0       0x22        // Front end TX configuration
#define CCxxx0_FSCAL3       0x23        // Frequency synthesizer calibration
#define CCxxx0_FSCAL2       0x24        // Frequency synthesizer calibration
#define CCxxx0_FSCAL1       0x25        // Frequency synthesizer calibration
#define CCxxx0_FSCAL0       0x26        // Frequency synthesizer calibration
#define CCxxx0_RCCTRL1      0x27        // RC oscillator configuration
#define CCxxx0_RCCTRL0      0x28        // RC oscillator configuration
#define CCxxx0_FSTEST       0x29        // Frequency synthesizer calibration control
#define CCxxx0_PTEST        0x2A        // Production test
#define CCxxx0_AGCTEST      0x2B        // AGC test
#define CCxxx0_TEST2        0x2C        // Various test settings
#define CCxxx0_TEST1        0x2D        // Various test settings
#define CCxxx0_TEST0        0x2E        // Various test settings
// Strobe commands
#define CCxxx0_SRES         0x30        // Reset chip.
#define CCxxx0_SFSTXON      0x31        // Enable and calibrate frequency synthesizer (if MCSM0.FS_AUTOCAL=1).
                                        // If in RX/TX: Go to a wait state where only the synthesizer is
                                        // running (for quick RX / TX turnaround).
#define CCxxx0_SXOFF        0x32        // Turn off crystal oscillator.
#define CCxxx0_SCAL         0x33        // Calibrate frequency synthesizer and turn it off
                                        // (enables quick start).
#define CCxxx0_SRX          0x34        // Enable RX. Perform calibration first if coming from IDLE and
                                        // MCSM0.FS_AUTOCAL=1.
#define CCxxx0_STX          0x35        // In IDLE state: Enable TX. Perform calibration first if
                                        // MCSM0.FS_AUTOCAL=1. If in RX state and CCA is enabled:
                                        // Only go to TX if channel is clear.
#define CCxxx0_SIDLE        0x36        // Exit RX / TX, turn off frequency synthesizer and exit
                                        // Wake-On-Radio mode if applicable.
#define CCxxx0_SAFC         0x37        // Perform AFC adjustment of the frequency synthesizer
#define CCxxx0_SWOR         0x38        // Start automatic RX polling sequence (Wake-on-Radio)
#define CCxxx0_SPWD         0x39        // Enter power down mode when CSn goes high.
#define CCxxx0_SFRX         0x3A        // Flush the RX FIFO buffer.
#define CCxxx0_SFTX         0x3B        // Flush the TX FIFO buffer.
#define CCxxx0_SWORRST      0x3C        // Reset real time clock.
#define CCxxx0_SNOP         0x3D        // No operation. May be used to pad strobe commands to two
                                        // INT8Us for simpler software.
#define CCxxx0_PARTNUM      0x30
#define CCxxx0_VERSION      0x31
#define CCxxx0_FREQEST      0x32
#define CCxxx0_LQI          0x33
#define CCxxx0_RSSI         0x34
#define CCxxx0_MARCSTATE    0x35
#define CCxxx0_WORTIME1     0x36
#define CCxxx0_WORTIME0     0x37
#define CCxxx0_PKTSTATUS    0x38
#define CCxxx0_VCO_VC_DAC   0x39
#define CCxxx0_TXBYTES      0x3A
#define CCxxx0_RXBYTES      0x3B

#define CCxxx0_PATABLE      0x3E
#define CCxxx0_TXFIFO       0x3F
#define CCxxx0_RXFIFO       0x3F
//******************************************************************************
//*****๦ʲÿϸοDATACC1100Ӣĵе48-49ҳĲ**********
//INT8U PaTabel[8] = {0x04 ,0x04 ,0x04 ,0x04 ,0x04 ,0x04 ,0x04 ,0x04};  //-30dBm   С
INT8U PaTabel[8] = {0x60 ,0x60 ,0x60 ,0x60 ,0x60 ,0x60 ,0x60 ,0x60};  //0dBm
//INT8U PaTabel[8] = {0xC0 ,0xC0 ,0xC0 ,0xC0 ,0xC0 ,0xC0 ,0xC0 ,0xC0};   //10dBm     
//=======================RF1100-1101Ĵṹ =================================
typedef struct S_RF_SETTINGS
{
    INT8U FSCTRL2;
    INT8U FSCTRL1;   // Frequency synthesizer control.
    INT8U FSCTRL0;   // Frequency synthesizer control.
    INT8U FREQ2;     // Frequency control word, high INT8U.
    INT8U FREQ1;     // Frequency control word, middle INT8U.
    INT8U FREQ0;     // Frequency control word, low INT8U.
    INT8U MDMCFG4;   // Modem configuration.
    INT8U MDMCFG3;   // Modem configuration.
    INT8U MDMCFG2;   // Modem configuration.
    INT8U MDMCFG1;   // Modem configuration.
    INT8U MDMCFG0;   // Modem configuration.
    INT8U CHANNR;    // Channel number.
    INT8U DEVIATN;   // Modem deviation setting (when FSK modulation is enabled).
    INT8U FREND1;    // Front end RX configuration.
    INT8U FREND0;    // Front end RX configuration.
    INT8U MCSM0;     // Main Radio Control State Machine configuration.
    INT8U FOCCFG;    // Frequency Offset Compensation Configuration.
    INT8U BSCFG;     // Bit synchronization Configuration.
    INT8U AGCCTRL2;  // AGC control.
    INT8U AGCCTRL1;  // AGC control.
    INT8U AGCCTRL0;  // AGC control.
    INT8U FSCAL3;    // Frequency synthesizer calibration.
    INT8U FSCAL2;    // Frequency synthesizer calibration.
    INT8U FSCAL1;    // Frequency synthesizer calibration.
    INT8U FSCAL0;    // Frequency synthesizer calibration.
    INT8U FSTEST;    // Frequency synthesizer calibration control
    INT8U TEST2;     // Various test settings.
    INT8U TEST1;     // Various test settings.
    INT8U TEST0;     // Various test settings.
    INT8U IOCFG2;    // GDO2 output pin configuration
    INT8U IOCFG0;    // GDO0 output pin configuration
    INT8U PKTCTRL1;  // Packet automation control.
    INT8U PKTCTRL0;  // Packet automation control.
    INT8U ADDR;      // Device address.
    INT8U PKTLEN;    // Packet length.
} RF_SETTINGS;
//==========================CC1100-1101Ĵ===============================
const RF_SETTINGS rfSettings = 
{
    0x00,
    0x08,   // FSCTRL1   Frequency synthesizer control.
    0x00,   // FSCTRL0   Frequency synthesizer control.
    0x10,   // FREQ2     Frequency control word, high byte.
    0xA7,   // FREQ1     Frequency control word, middle byte.
    0x62,   // FREQ0     Frequency control word, low byte.
    0x5B,   // MDMCFG4   Modem configuration.
    0xF8,   // MDMCFG3   Modem configuration.
    0x03,   // MDMCFG2   Modem configuration.
    0x22,   // MDMCFG1   Modem configuration.
    0xF8,   // MDMCFG0   Modem configuration.

    0x00,   // CHANNR    Channel number.
    0x47,   // DEVIATN   Modem deviation setting (when FSK modulation is enabled).
    0xB6,   // FREND1    Front end RX configuration.
    0x10,   // FREND0    Front end RX configuration.
    0x18,   // MCSM0     Main Radio Control State Machine configuration.
    0x1D,   // FOCCFG    Frequency Offset Compensation Configuration.
    0x1C,   // BSCFG     Bit synchronization Configuration.
    0xC7,   // AGCCTRL2  AGC control.
    0x00,   // AGCCTRL1  AGC control.
    0xB2,   // AGCCTRL0  AGC control.

    0xEA,   // FSCAL3    Frequency synthesizer calibration.
    0x2A,   // FSCAL2    Frequency synthesizer calibration.
    0x00,   // FSCAL1    Frequency synthesizer calibration.
    0x11,   // FSCAL0    Frequency synthesizer calibration.
    0x59,   // FSTEST    Frequency synthesizer calibration.
    0x81,   // TEST2     Various test settings.
    0x35,   // TEST1     Various test settings.
    0x09,   // TEST0     Various test settings.
    0x0B,   // IOCFG2    GDO2 output pin configuration.
    0x06,   // IOCFG0D   GDO0 output pin configuration. Refer to SmartRF?Studio User Manual for detailed pseudo register explanation.

    0x04,   // PKTCTRL1  Packet automation control.
    0x05,   // PKTCTRL0  Packet automation control.
    0x00,   // ADDR      Device address.
    0xff    // PKTLEN    Packet length.
};
//===========================LED˿==========================================
void LED_IO_set(void)
{    
        P6DIR |= 0x06;   P6SEL&=0xf9;        
}
//******************************************************************************
//ϵͳʼ
//******************************************************************************
void InitSys()
{
   unsigned int iq0;
   _DINT();
   BCSCTL1 &=~XT2OFF;
   do
   {
      IFG1 &= ~OFIFG;		         // ʧЧ־
  for (iq0 = 0xFF; iq0 > 0; iq0--);	// ʱȴXT2
   }
   while ((IFG1 & OFIFG) != 0);		// жXT2Ƿ		
   BCSCTL2 =SELM1+SELS;                      //MCLK,SMCLKʱΪXT2
}
//******************************SPI״̬ʼ***********************************
void SpiInit(void)
{
    P3DIR |= 0xC0; P3DIR |= 0xFB;   P3SEL&=0xF0;   
}																				  
//==============================================================================
void RF1100_IO_set(void)
{
     SpiInit();
     P2DIR &= 0x3f;   P2SEL&=0x3f;   

}
//==============================================================================
//******************************************************************************
//delay(unsigned int s)
//룺ʱ
//
//ͨ͢ʱ,ڲ
//******************************************************************************		
void delay(unsigned int s)
{
	unsigned int i;
	for(i=0; i<s; i++);
	for(i=0; i<s; i++);
}
//========================ʱԼ5ms=============================================
void Delay5ms(void)
{ 
    INT16U i=40000;
    while (i != 0)
    {
        i--;
    }
}
//******************************************************************************
void halWait(INT16U timeout)
{
char i;
    do 
    {
       for(i=0; i<20; i++);
    } while (--timeout);
}
//******************************************************************************
//SpisendByte(INT8U dat)
//룺͵
//
//SPIһֽ
//******************************************************************************
INT8U SpiTxRxByte(INT8U dat)
{
//----------------------ģSPIʱʽ-----------------------------------
	INT8U i,temp;
	temp = 0;	
	SCK_0 ;
	for(i=0; i<8; i++)
	{
		if(dat & 0x80)
		{
	           MOSI_1;
		}
		else 
		{
		   MOSI_0;
		}
		dat <<= 1;
	        SCK_1; 
		temp <<= 1;
		//a=Read_CC1100_MISO;  //ȡMISO״̬
		if(P3IN& 0x04)temp++; 
		SCK_0 ;
	}
	return temp;
}
//*******************************************************************************
//void RESET_CC1100(void)
//룺
//
//λCC1100
//*****************************************************************************************
void RESET_CC1100(void) 
{
    CSN_0 ; 
	while (P3IN & 0x04);
    SpiTxRxByte(CCxxx0_SRES); 		//д븴λ
	while (P3IN & 0x04); 
    CSN_1; 
}
//*****************************************************************************************
//void POWER_UP_RESET_CC1100(void) 
//룺
//
//ϵ縴λCC1100
//*****************************************************************************************
void POWER_UP_RESET_CC1100(void) 
{
	CSN_1; 
	halWait(1); 
	CSN_0 ; 
	halWait(1); 
	CSN_1; 
	halWait(41); 
	RESET_CC1100();   		//λCC1100
}
//*****************************************************************************************
//void halSpiWriteReg(INT8U addr, INT8U value)
//룺ַ
//
//SPIдĴ
//*****************************************************************************************
void halSpiWriteReg(INT8U addr, INT8U value) 
{
  
    CSN_0;
    while (P3IN& 0x04);
    SpiTxRxByte(addr);		//дַ
    SpiTxRxByte(value);		//д
    CSN_1;
}
//*****************************************************************************************
//void halSpiWriteBurstReg(INT8U addr, INT8U *buffer, INT8U count)
//룺ַд뻺д
//
//SPIдüĴ
//*****************************************************************************************
void halSpiWriteBurstReg(INT8U addr, INT8U *buffer, INT8U count) 
{
    INT8U i, temp;
	temp = addr | WRITE_BURST;
    CSN_0;
    while (P3IN & 0x04);
    SpiTxRxByte(temp);
    for (i = 0; i < count; i++)
 	{
        SpiTxRxByte(buffer[i]);
    }
    CSN_1;
}
//*****************************************************************************************
//void halSpiStrobe(INT8U strobe)
//룺
//
//SPIд
//*****************************************************************************************
void halSpiStrobe(INT8U strobe) 
{
    CSN_0;
    while (P3IN & 0x04);
    SpiTxRxByte(strobe);		//д
    CSN_1;
}
//*****************************************************************************************
//INT8U halSpiReadReg(INT8U addr)
//룺ַ
//üĴ
//SPIĴ
//*****************************************************************************************
INT8U halSpiReadReg(INT8U addr) 
{
	INT8U temp, value;
    temp = addr|READ_SINGLE;//Ĵ
	CSN_0;
	while (P3IN & 0x04);
	SpiTxRxByte(temp);
	value = SpiTxRxByte(0);
	CSN_1;
	return value;
}
//*****************************************************************************************
//void halSpiReadBurstReg(INT8U addr, INT8U *buffer, INT8U count)
//룺ַݺݴĻø
//
//SPIдüĴ
//*****************************************************************************************
void halSpiReadBurstReg(INT8U addr, INT8U *buffer, INT8U count) 
{
    INT8U i,temp;
	temp = addr | READ_BURST;		//дҪüĴַͶ
    CSN_0;
    while (P3IN & 0x04);
	SpiTxRxByte(temp);   
    for (i = 0; i < count; i++) 
	{
        buffer[i] = SpiTxRxByte(0);
    }
    CSN_1;
}
//*****************************************************************************************
//INT8U halSpiReadReg(INT8U addr)
//룺ַ
//״̬Ĵǰֵ
//SPI״̬Ĵ
//*****************************************************************************************
INT8U halSpiReadStatus(INT8U addr) 
{
    INT8U value,temp;
	temp = addr | READ_BURST;		//дҪ״̬Ĵĵַͬʱд
    CSN_0;
    while (P3IN & 0x04);
    SpiTxRxByte(temp);
	value = SpiTxRxByte(0);
	CSN_1;
	return value;
}
//*****************************************************************************************
//void halRfWriteRfSettings(RF_SETTINGS *pRfSettings)
//룺
//
//CC1100ļĴ
//*****************************************************************************************
void halRfWriteRfSettings(void) 
{
    halSpiWriteReg(CCxxx0_FSCTRL0,  rfSettings.FSCTRL2);//Ѽӵ
    // Write register settings
    halSpiWriteReg(CCxxx0_FSCTRL1,  rfSettings.FSCTRL1);
    halSpiWriteReg(CCxxx0_FSCTRL0,  rfSettings.FSCTRL0);
    halSpiWriteReg(CCxxx0_FREQ2,    rfSettings.FREQ2);
    halSpiWriteReg(CCxxx0_FREQ1,    rfSettings.FREQ1);
    halSpiWriteReg(CCxxx0_FREQ0,    rfSettings.FREQ0);
    halSpiWriteReg(CCxxx0_MDMCFG4,  rfSettings.MDMCFG4);
    halSpiWriteReg(CCxxx0_MDMCFG3,  rfSettings.MDMCFG3);
    halSpiWriteReg(CCxxx0_MDMCFG2,  rfSettings.MDMCFG2);
    halSpiWriteReg(CCxxx0_MDMCFG1,  rfSettings.MDMCFG1);
    halSpiWriteReg(CCxxx0_MDMCFG0,  rfSettings.MDMCFG0);
    halSpiWriteReg(CCxxx0_CHANNR,   rfSettings.CHANNR);
    halSpiWriteReg(CCxxx0_DEVIATN,  rfSettings.DEVIATN);
    halSpiWriteReg(CCxxx0_FREND1,   rfSettings.FREND1);
    halSpiWriteReg(CCxxx0_FREND0,   rfSettings.FREND0);
    halSpiWriteReg(CCxxx0_MCSM0 ,   rfSettings.MCSM0 );
    halSpiWriteReg(CCxxx0_FOCCFG,   rfSettings.FOCCFG);
    halSpiWriteReg(CCxxx0_BSCFG,    rfSettings.BSCFG);
    halSpiWriteReg(CCxxx0_AGCCTRL2, rfSettings.AGCCTRL2);
    halSpiWriteReg(CCxxx0_AGCCTRL1, rfSettings.AGCCTRL1);
    halSpiWriteReg(CCxxx0_AGCCTRL0, rfSettings.AGCCTRL0);
    halSpiWriteReg(CCxxx0_FSCAL3,   rfSettings.FSCAL3);
    halSpiWriteReg(CCxxx0_FSCAL2,   rfSettings.FSCAL2);
    halSpiWriteReg(CCxxx0_FSCAL1,   rfSettings.FSCAL1);
    halSpiWriteReg(CCxxx0_FSCAL0,   rfSettings.FSCAL0);
    halSpiWriteReg(CCxxx0_FSTEST,   rfSettings.FSTEST);
    halSpiWriteReg(CCxxx0_TEST2,    rfSettings.TEST2);
    halSpiWriteReg(CCxxx0_TEST1,    rfSettings.TEST1);
    halSpiWriteReg(CCxxx0_TEST0,    rfSettings.TEST0);
    halSpiWriteReg(CCxxx0_IOCFG2,   rfSettings.IOCFG2);
    halSpiWriteReg(CCxxx0_IOCFG0,   rfSettings.IOCFG0);    
    halSpiWriteReg(CCxxx0_PKTCTRL1, rfSettings.PKTCTRL1);
    halSpiWriteReg(CCxxx0_PKTCTRL0, rfSettings.PKTCTRL0);
    halSpiWriteReg(CCxxx0_ADDR,     rfSettings.ADDR);
    halSpiWriteReg(CCxxx0_PKTLEN,   rfSettings.PKTLEN);
}
//*****************************************************************************************
//void halRfSendPacket(INT8U *txBuffer, INT8U size)
//룺͵Ļݸ
//
//CC1100һ
//*****************************************************************************************

void halRfSendPacket(INT8U *txBuffer, INT8U size) 
{
    halSpiWriteReg(CCxxx0_TXFIFO, size);
    halSpiWriteBurstReg(CCxxx0_TXFIFO, txBuffer, size);	//дҪ͵
    halSpiStrobe(CCxxx0_STX);		//뷢ģʽ
    // Wait for GDO0 to be set -> sync transmitted
    while (!(P2IN & 0x80));
    // Wait for GDO0 to be cleared -> end of packet
    while (P2IN & 0x80);
	halSpiStrobe(CCxxx0_SFTX);
}
//------------------------------------------------------------------------------
void setRxMode(void)
{
    halSpiStrobe(CCxxx0_SRX);		//״̬
}
//------------------------------------------------------------------------------
INT8U halRfReceivePacket(INT8U *rxBuffer, INT8U *length) 
{
    INT8U status[2];
    INT8U packetLength;
	INT8U i=(*length)*4;  // Ҫdataratelength
    halSpiStrobe(CCxxx0_SRX);		//״̬
	delay(2);
	while (P2IN & 0x80)
	{
		delay(2);
		--i;
		if(i<1)
		   return 0; 	    
	}	 
    if ((halSpiReadStatus(CCxxx0_RXBYTES) & BYTES_IN_RXFIFO)) //ӵֽΪ0
	{
        packetLength = halSpiReadReg(CCxxx0_RXFIFO);//һֽڣֽΪ֡ݳ
        if (packetLength <= *length) 		//ҪЧݳСڵڽյݰĳ
		{
            halSpiReadBurstReg(CCxxx0_RXFIFO, rxBuffer, packetLength); //нյ
            *length = packetLength;				//ѽݳȵ޸Ϊǰݵĳ
            // Read the 2 appended status bytes (status[0] = RSSI, status[1] = LQI)
            halSpiReadBurstReg(CCxxx0_RXFIFO, status, 2); 	//CRCУλ
			halSpiStrobe(CCxxx0_SFRX);		//ϴջ
            return (status[1] & CRC_OK);			//Уɹؽճɹ
        }
		 else 
		{
            *length = packetLength;
            halSpiStrobe(CCxxx0_SFRX);		//ϴջ
            return 0;
        }
    } 
	else
 	return 0;
}
//=============================================================================
main()
{
        INT8U leng =32;        // 8ֽ, Ҫݰ,ȷ
	INT8U TxBuf[32]=
        { 0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08,0x11,0x12,0x13,0x14,0x15,0x16,0x17,0x18,
          0x21,0x22,0x23,0x24,0x25,0x26,0x27,0x28, 0x31,0x32,0x33,0x34,0x35,0x36,0x37,0x38,
        };	 
	//INT8U RxBuf[8];	
        WDTCTL = WDTPW + WDTHOLD; //ֹŹ
        LED_IO_set();
        InitSys();
        RF1100_IO_set();
	POWER_UP_RESET_CC1100();
	halRfWriteRfSettings();
	halSpiWriteBurstReg(CCxxx0_PATABLE, PaTabel, 8);
        LED1_1;LED2_1;
        while(1)
        {
          halRfSendPacket(TxBuf,leng);	// TXUBF ѭͳȥ
        }
}